//: QUE2.CPP -- simple queue using templates
//. Adapted from "Using C++" 2nd edition, Osborne/McGraw-Hill 1992
//. by Bruce Eckel
#include <iostream.h>
#include "ostring.h"

template<class T> class queue {
  enum { size = 10 };
  T *q[size];
  int in, out; // indexes
public:
  queue() : in(0), out(0) {}
  void add(T * i) {
    q[in++] = i;
    if(in >= size) in = 0;  // wrap
  }
  T* get() {
    if(out == in) return 0;
    T *result = q[out++];
    if(out >= size) out = 0;
    return result;
  }
};

void main() {
  int I[] = { 1, 3, 5, 7, 11, 13 };
  queue<int> iq;  // an int queue
  for(int i = 0; i < sizeof(I)/sizeof(I[0]); i++)
    iq.add(&I[i]);
  for(int* p = iq.get(); p; p = iq.get())
    cout << "iq.get() = " << *p << endl;

  String S[] = { "this", "is", "a", "queue", "too" };
  queue<String> sq; // a string queue
  for(i = 0; i < sizeof(S)/sizeof(S[0]); i++)
    sq.add(&S[i]);
  for(String* sp = sq.get(); sp; sp = sq.get())
    cout << "sq.get() = " << *sp << endl;
}
