//: TFUNC.CPP -- function templates
//. Adapted from "Using C++" 2nd edition, Osborne/McGraw-Hill 1992
//. by Bruce Eckel
#include <time.h>
#include <stdlib.h>
#include <iostream.h>

template<class T>
void swap(T& a, T& b) {
  T tmp = a;  // copy constructor
  a = b;      // operator=
  b = tmp;
}

// A selection sort:
template<class T>
void sort(T L[], const int sz) {
  for(int i = 0; i < sz - 1; i++) {
    int min = i;
    for(int j = i+1; j < sz; j++)
      if(L[j] < L[min]) min = j;
    swap(L[min], L[i]);
  }
}

void main() {
  srand((unsigned)time(new time_t));
  const sz = 20;
  int X[sz], Y[sz];
  for(int i = 0; i < sz; i++)
    X[i] = Y[i] = rand() % 100;
  sort(X, sz);
  for(i = 0; i < sz; i++)
    cout << "Y = " << Y[i] << "\t\tX = " << X[i] << endl;
}
